SystemOrganization addCategory: #'Egg-Core'!
SystemOrganization addCategory: #'Egg-Evas'!
SystemOrganization addCategory: #'Egg-NBEina'!
SystemOrganization addCategory: #'Egg-NBEvas'!
SystemOrganization addCategory: #'Egg-SDL'!
SystemOrganization addCategory: #'Egg-Tests-Evas'!

Link subclass: #EvasObject
	instanceVariableNames: 'x y width height color visible handler callbacks nbCallbacks evas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

EvasObject subclass: #EvasImage
	instanceVariableNames: 'sourceFile key imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 11/15/2012 02:04'!
bindOn: aNBEvas

	handler := aNBEvas addImage.! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 4/8/2012 00:11'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addImage.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageHeight
	^ imageHeight! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageHeight: anObject
	imageHeight := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageWidth
	^ imageWidth! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageWidth: anObject
	imageWidth := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'initialize-release' stamp: 'EgorScorik 1/5/2012 01:21'!
initialize 

	super initialize.
	imageWidth := 0.
	imageHeight := 0.
	sourceFile := ''.
	key := ''.
! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
key
	^ key! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:48'!
key: anObject
	key := anObject.
	self updateFile.! !

!EvasImage methodsFor: 'errors' stamp: 'EgorScorik 1/5/2012 00:31'!
loadError
	^ self handler loadErrorFromCode: self handler loadErrorCode! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
sourceFile
	^ sourceFile! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:47'!
sourceFile: anObject
	sourceFile := anObject.
	self updateFile! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFile.
	! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 01:36'!
updateFile
	handler
		ifNotNil: [ 
			handler setFile: sourceFile key: key.
			self updateImageSize ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 21:35'!
updateImageSize
	handler
		ifNotNil: [ 
			handler getImageInfo.
			imageWidth := handler imageWidth.
			imageHeight := handler imageHeight.
			self width: imageWidth.
			self height: imageHeight ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 00:09'!
updateSize
	(width = 0 or: height = 0)
		ifFalse: [ handler ifNotNil: [ handler width: width height: height ] ]! !

EvasObject subclass: #EvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasLine methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:05'!
bindOn: aNBEvas

	handler := aNBEvas addLine.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:54'!
addCallback: callback withTypeId: type andKey: key
	| nbCallback |
	(callbacks includes: callback)
		ifTrue: [ 
			handler addCallback: (nbCallbacks at: key) type: type data: nil.
			 ]
		ifFalse: [ 
			nbCallback := NBEvasObjectCallback on: [ :data :e :obj :params | callback cull: params ].
			handler addCallback: nbCallback type: type data: nil.
			(callbacks at: key ifAbsentPut: [ Set new ]) add: callback.
			(nbCallbacks at: key ifAbsentPut: [ Set new ]) add: nbCallback ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:03'!
bindOn: aNBEvas

	self subclassResponsibility.! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
color
	^ color! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:28'!
color: anObject
	color := anObject.
	self updateColor.! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 6/15/2013 00:51'!
evas
	^ evas! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 6/15/2013 00:51'!
evas: anObject
	evas := anObject! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 00:53'!
free

	handler ifNotNil: [ handler free ].! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler
	^ handler! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler: nbEvasObject
	^ handler := nbEvasObject! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
height
	^ height! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:32'!
height: anObject
	height := anObject.
	self updateSize! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 11/16/2012 01:46'!
initialize 

	callbacks := Dictionary new.
	nbCallbacks := Dictionary new.
	
	x := 0.
	y := 0.
	width := 0.
	height := 0.
	visible := true.! !

!EvasObject methodsFor: 'move-resize' stamp: 'EgorScorik 5/13/2012 16:20'!
moveTo: aPoint

	x := aPoint x.
	y := aPoint y.
	self updateXY.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onFocusIn: callback

	self addCallback: callback withTypeId: 12 andKey: #onFocusIn:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onFocusOut: callback

	self addCallback: callback withTypeId: 13 andKey: #onFocusOut:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onFree: callback

	self addCallback: callback withTypeId: 9 andKey: #onFree:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onHide: callback

	self addCallback: callback withTypeId: 15 andKey: #onHide:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onKeyDown: callback

	self addCallback: callback withTypeId: 10 andKey: #onKeyDown:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onKeyUp: callback

	self addCallback: callback withTypeId: 11 andKey: #onKeyUp:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onMouseDown: callback

	self addCallback: callback withTypeId: 2 andKey: #onMouseDown:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:42'!
onMouseIn: callback

	self addCallback: callback withTypeId: 0 andKey: #onMouseIn:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onMouseMove: callback

	self addCallback: callback withTypeId: 4 andKey: #onMouseMove:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onMouseOut: callback

	self addCallback: callback withTypeId: 1 andKey: #onMouseOut:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onMouseUp: callback

	self addCallback: callback withTypeId: 3 andKey: #onMouseUp:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:43'!
onMouseWheel: callback

	self addCallback: callback withTypeId: 5 andKey: #onMouseWheel:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:44'!
onMove: callback

	self addCallback: callback withTypeId: 16 andKey: #onMove:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:44'!
onResize: callback

	self addCallback: callback withTypeId: 17 andKey: #onResize:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:44'!
onRestack: callback

	self addCallback: callback withTypeId: 18 andKey: #onRestack:! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 6/19/2013 00:44'!
onShow: callback

	self addCallback: callback withTypeId: 14 andKey: #onShow:! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 6/19/2013 01:00'!
regenerate
	self evas ifNotNil: [ evas add: self ].
	callbacks
		keysAndValuesDo: [ :key :callbacksList | callbacksList do: [ :callback | self perform: key with: callback ] ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	self
		updateXY;
		updateSize;
		updateColor;
		updateVisibility! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/5/2012 00:11'!
updateColor
	(handler isNil or: color isNil) ifFalse: [
			handler
				colorR: (color red * 255) asInteger
				G: (color green * 255) asInteger
				B: (color blue * 255) asInteger
				A: (color alpha * 255) asInteger ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:46'!
updateHandler: anEvas
	anEvas ifNil: [ ^self ].
	self handler: (self getNBEvasObjectFor: anEvas handler).
	self update! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateSize
	handler ifNotNil: [ handler width: width height: height ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:06'!
updateVisibility
	handler
		ifNotNil: [ 
			self visible
				ifTrue: [ handler show ]
				ifFalse: [ handler hide ] ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateXY
	handler ifNotNil: [ handler moveToX: x Y: y ]! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
visible
	^ visible! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:07'!
visible: anObject
	visible := anObject.
	self updateVisibility! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
width
	^ width! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
width: anObject
	width := anObject.
	self updateSize! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
x
	^ x! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
x: anObject
	x := anObject.
	self updateXY! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
y
	^ y! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
y: anObject
	y := anObject.
	self updateXY! !

EvasObject subclass: #EvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasPolygon methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:06'!
bindOn: aNBEvas

	handler := aNBEvas addPolygon.! !

EvasObject subclass: #EvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:26'!
bindOn: aNBEvas

	handler := aNBEvas addRectangle.! !

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	! !

EvasObject subclass: #EvasText
	instanceVariableNames: 'fontName text fontSize fontSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 11/15/2012 02:07'!
bindOn: aNBEvas

	handler := aNBEvas addText.! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font
	^ fontName! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font: anObject
	fontName := anObject.
	self updateFont.! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 03:11'!
font: anObject size: size
	fontName := anObject.
	fontSize := size.
	self updateFont! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:06'!
fontSize
	^ fontSize! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:25'!
fontSize: anObject
	fontSize := anObject.
	self updateFont.
	! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource
	^ fontSource! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource: anObject
	fontSource := anObject.
	self updateFontSource.! !

!EvasText methodsFor: 'initialize-release' stamp: 'EgorScorik 1/6/2012 02:05'!
initialize 

	super initialize.
	fontName := 'Arial'.
	text := ''.
	fontSize := 12.
! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:03'!
text
	^ text! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:12'!
text: anObject
	text := anObject.
	self updateText! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFont.
	self updateFontSource.
	self updateText.! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:14'!
updateFont
	handler ifNotNil: [ handler setFont: fontName size: fontSize. ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:31'!
updateFontSource
	handler ifNotNil: [ fontSource ifNotNil: [ handler setFontSource: fontSource ] ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:12'!
updateText
	handler ifNotNil: [ handler setText: text ]! !

EvasObject subclass: #EvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasTextblock methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:07'!
bindOn: aNBEvas

	handler := aNBEvas addTextblock.! !

NBExternalStructure variableByteSubclass: #NBEvasEngineInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasEngineInfo commentStamp: '<historical>' prior: 0!
I am abstract evas engine information structure.
My instance is argument for evas_engine_info_set and value of evas_engine_info_get
!

!NBEvasEngineInfo class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/12/2012 02:57'!
renderMethod
	self subclassResponsibility.! !

NBEvasEngineInfo variableByteSubclass: #NBEvasEngineInfoSDL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasEngineInfoSDL commentStamp: '<historical>' prior: 0!
I am evas SDL engine information structure.!

!NBEvasEngineInfoSDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/8/2013 03:29'!
fieldsDesc
	^ #(
		int magic;
		int fullscreen;
		void* window;
		void* glContext;
		)! !

!NBEvasEngineInfoSDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 03:51'!
renderMethod
	^'gl_sdl'! !

SharedPool subclass: #SDLConstants
	instanceVariableNames: ''
	classVariableNames: 'AnnouncementClasses EventClasses'
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLConstants commentStamp: '<historical>' prior: 0!
C-side stuff for SDL!

!SDLConstants class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/8/2013 05:22'!
eventClasses

"
/**
 * \brief The types of events that can be delivered.
 */
typedef enum
{
    SDL_FIRSTEVENT     = 0,     /**< Unused (do not remove) */

    /* Application events */
    SDL_QUIT           = 0x100, /**< User-requested quit */

    /* Window events */
    SDL_WINDOWEVENT    = 0x200, /**< Window state change */
    SDL_SYSWMEVENT,             /**< System specific event */

    /* Keyboard events */
    SDL_KEYDOWN        = 0x300, /**< Key pressed */
    SDL_KEYUP,                  /**< Key released */
    SDL_TEXTEDITING,            /**< Keyboard text editing (composition) */
    SDL_TEXTINPUT,              /**< Keyboard text input */

    /* Mouse events */
    SDL_MOUSEMOTION    = 0x400, /**< Mouse moved */
    SDL_MOUSEBUTTONDOWN,        /**< Mouse button pressed */
    SDL_MOUSEBUTTONUP,          /**< Mouse button released */
    SDL_MOUSEWHEEL,             /**< Mouse wheel motion */

    /* Tablet or multiple mice input device events */
    SDL_INPUTMOTION    = 0x500, /**< Input moved */
    SDL_INPUTBUTTONDOWN,        /**< Input button pressed */
    SDL_INPUTBUTTONUP,          /**< Input button released */
    SDL_INPUTWHEEL,             /**< Input wheel motion */
    SDL_INPUTPROXIMITYIN,       /**< Input pen entered proximity */
    SDL_INPUTPROXIMITYOUT,      /**< Input pen left proximity */

    /* Joystick events */
    SDL_JOYAXISMOTION  = 0x600, /**< Joystick axis motion */
    SDL_JOYBALLMOTION,          /**< Joystick trackball motion */
    SDL_JOYHATMOTION,           /**< Joystick hat position change */
    SDL_JOYBUTTONDOWN,          /**< Joystick button pressed */
    SDL_JOYBUTTONUP,            /**< Joystick button released */
    SDL_JOYDEVICEADDED,         /**< A new joystick has been inserted into the system */
    SDL_JOYDEVICEREMOVED,       /**< An opened joystick has been removed */

	/* Game controller events */
	SDL_CONTROLLERAXISMOTION  = 0x650, /**< Game controller axis motion */
	SDL_CONTROLLERBUTTONDOWN,          /**< Game controller button pressed */
	SDL_CONTROLLERBUTTONUP,            /**< Game controller button released */
	SDL_CONTROLLERDEVICEADDED,         /**< A new Game controller has been inserted into the system */
	SDL_CONTROLLERDEVICEREMOVED,       /**< An opened Game controller has been removed */

    /* Touch events */
    SDL_FINGERDOWN      = 0x700,
    SDL_FINGERUP,
    SDL_FINGERMOTION,
    SDL_TOUCHBUTTONDOWN,
    SDL_TOUCHBUTTONUP,    

    /* Gesture events */
    SDL_DOLLARGESTURE   = 0x800,
    SDL_DOLLARRECORD,
    SDL_MULTIGESTURE,

    /* Clipboard events */
    SDL_CLIPBOARDUPDATE = 0x900, /**< The clipboard changed */

    /* Drag and drop events */
    SDL_DROPFILE        = 0x1000, /**< The system requests a file open */

    /** Events ::SDL_USEREVENT through ::SDL_LASTEVENT are for your use,
     *  and should be allocated with SDL_RegisterEvents()
     */
    SDL_USEREVENT    = 0x8000,

    /**
     *  This last event is only for bounding internal arrays
     */
    SDL_LASTEVENT    = 0xFFFF
} SDL_EventType;
"
	EventClasses := Dictionary new.
	AnnouncementClasses := Dictionary new.
		
	AnnouncementClasses at: 16r100 put: Quit.
	EventClasses at: 16r100 put: SDLEvent.
	AnnouncementClasses at: 16r300 put: KeyDown.
	EventClasses at: 16r300 put: SDLKeyboardEvent.
	AnnouncementClasses at: 16r301 put: KeyUp.
	EventClasses at: 16r301 put: SDLKeyboardEvent.
	AnnouncementClasses at: 16r400 put: MouseMove.
	EventClasses at: 16r400 put: SDLMouseMotionEvent .
	AnnouncementClasses at: 16r401 put: MouseDown.
	EventClasses at: 16r401 put: SDLMouseButtonEvent .
	AnnouncementClasses at: 16r402 put: MouseUp.
	EventClasses at: 16r402 put: SDLMouseButtonEvent.
! !

!SDLConstants class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/30/2013 00:14'!
initialize

	self eventClasses.
! !

NBExternalStructure variableByteSubclass: #SDLEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'SDLConstants'
	category: 'Egg-SDL'!

!SDLEvent commentStamp: '<historical>' prior: 0!
SDLEvent on C-side is union. I am structure who can contain any of SDL events.

typedef union{
  Uint8 type;
  SDL_ActiveEvent active;
  SDL_KeyboardEvent key;
  SDL_MouseMotionEvent motion;
  SDL_MouseButtonEvent button;
  SDL_JoyAxisEvent jaxis;
  SDL_JoyBallEvent jball;
  SDL_JoyHatEvent jhat;
  SDL_JoyButtonEvent jbutton;
  SDL_ResizeEvent resize;
  SDL_ExposeEvent expose;
  SDL_QuitEvent quit;
  SDL_UserEvent user;
  SDL_SywWMEvent syswm;
} SDL_Event;
!

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/13/2013 01:12'!
announcementFrom: anEvent
	| annClass eventClass |
	annClass := AnnouncementClasses at: anEvent type ifAbsent: [^nil].
	eventClass := EventClasses at: anEvent type ifAbsent: [^nil].
	^annClass fromEvent: (eventClass fromPointer: anEvent)
! !

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/14/2013 02:19'!
fieldsDesc

	^ #(uint type)! !

!SDLEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/8/2013 04:41'!
instanceSize
	"sizeof(SDL_Event)"
	^56! !

SDLEvent variableByteSubclass: #SDLKeyboardEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLKeyboardEvent commentStamp: '<historical>' prior: 0!
/** Keyboard event structure */

typedef struct SDL_KeyboardEvent {
	Uint8 type;	/**< SDL_KEYDOWN or SDL_KEYUP */
	Uint8 which;	/**< The keyboard device index */
	Uint8 state;	/**< SDL_PRESSED or SDL_RELEASED */
	SDL_keysym keysym;
} SDL_KeyboardEvent;

typedef struct SDL_keysym {
	Uint8 scancode;			/**< hardware specific scancode */
	SDLKey sym;			/**< SDL virtual keysym */
	SDLMod mod;			/**< current key modifiers */
	Uint16 unicode;			/**< translated character */
} SDL_keysym;
!

!SDLKeyboardEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/14/2013 02:17'!
fieldsDesc

	^ #(uint type;
		uint timestamp;
		uint windowId;
		
		byte state;
		byte repeat;
		byte padding2;
		byte padding3;
		
		uint scancode;
		int sym;
		short mod;
		)! !

SDLEvent variableByteSubclass: #SDLMouseButtonEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseButtonEvent commentStamp: '<historical>' prior: 0!
/** Mouse button event structure */
typedef struct SDL_MouseButtonEvent {
	Uint8 type;	/**< SDL_MOUSEBUTTONDOWN or SDL_MOUSEBUTTONUP */
	Uint8 which;	/**< The mouse device index */
	Uint8 button;	/**< The mouse button index */
	Uint8 state;	/**< SDL_PRESSED or SDL_RELEASED */
	Uint16 x, y;	/**< The X/Y coordinates of the mouse at press time */
} SDL_MouseButtonEvent;!

!SDLMouseButtonEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/18/2013 23:09'!
fieldsDesc
	^ #(uint type;
		uint timestamp;
		uint windowId;
		uint which;
		byte button;
		byte state;
		byte padding1;
		byte padding2;
		int x;
		int y;
		)! !

SDLEvent variableByteSubclass: #SDLMouseMotionEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseMotionEvent commentStamp: '<historical>' prior: 0!
/**
 *  \brief Mouse motion event structure (event.motion.*)
 */
typedef struct SDL_MouseMotionEvent
{
    Uint32 type;        /**< ::SDL_MOUSEMOTION */
    Uint32 timestamp;
    Uint32 windowID;    /**< The window with mouse focus, if any */
    Uint32 which;       /**< The mouse instance id, or SDL_TOUCH_MOUSEID */
    Uint32 state;       /**< The current button state */
    Sint32 x;           /**< X coordinate, relative to window */
    Sint32 y;           /**< Y coordinate, relative to window */
    Sint32 xrel;        /**< The relative motion in the X direction */
    Sint32 yrel;        /**< The relative motion in the Y direction */
} SDL_MouseMotionEvent;!

!SDLMouseMotionEvent class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/18/2013 23:10'!
fieldsDesc
	^ #(uint type;
		uint timestamp;
		uint windowId;
		uint which;
		byte state;
		byte padding1;
		byte padding2;
		byte padding3;
		int x;
		int y;
		int xrel;
		int yrel;
		)! !

NBExternalObject subclass: #NBEinaIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaIterator class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libeina.so'! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 13:17'!
asArray
	| pointer array |
	array := OrderedCollection new.
	[ pointer := self next ] whileNotNil: [ array add: pointer ].
	^ array! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:27'!
asStringArray
	^self asArray collect: [:each | each readString. ]! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:19'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void eina_iterator_free (#NBEinaIterator self))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:13'!
getNext: data
"
/**
 * @brief Return the value of the current element and go to the next one.
 *
 * @param iterator The iterator.
 * @param data The data of the element.
 * @return #EINA_TRUE on success, #EINA_FALSE otherwise.
 *
 * This function returns the value of the current element pointed by
 * @p iterator in @p data, then goes to the next element. If @p
 * iterator is @c NULL or if a problem occurred, #EINA_FALSE is
 * returned, otherwise #EINA_TRUE is returned.
 */
EAPI Eina_Bool eina_iterator_next(Eina_Iterator *iterator,
                                  void         **data) EINA_ARG_NONNULL(1, 2) EINA_WARN_UNUSED_RESULT;
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int eina_iterator_next (#NBEinaIterator self, NBExternalAddress* data))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:15'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:11'!
next
	|result|
	result := NBExternalAddress new.
	
	^((self getNext: result) = 1) ifTrue: [result ] ifFalse: [nil].! !

NBExternalObject subclass: #NBEinaList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaList class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libeina.so'! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:33'!
asArray
	| iterator array |
	iterator := self iterator.
	array := iterator asArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:34'!
asStringArray
	| iterator array |
	iterator := self iterator.
	array := iterator asStringArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'accessing' stamp: 'EgorScorik 5/7/2012 12:14'!
iterator
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEinaIterator eina_list_iterator_new (#NBEinaList self))! !

!NBEinaList methodsFor: 'nativeboost' stamp: 'EgorScorik 2/11/2012 20:24'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

NBExternalObject subclass: #NBEvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvas commentStamp: '<historical>' prior: 0!
I am native boost wrapper for libevas general functions on my class side and Evas (canvas instance) on my instance side.

http://docs.enlightenment.org/auto/evas/modules.html!

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/7/2013 02:32'!
init
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int evas_init ())! !

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libevas.so'! !

!NBEvas class methodsFor: 'initialize-release' stamp: 'EgorScorik 6/8/2013 02:59'!
new
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEvas evas_new ())! !

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/7/2013 02:32'!
shutdown
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_shutdown ())! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:21'!
addImage
"
Evas_Object* evas_object_image_filled_add	(Evas * 	e)
Creates a new image object that automatically scales its bound image to the object's area, on both axis.

Parameters:
e	The given canvas.
Returns:
The created image object handle.
This is a helper function around evas_object_image_add() and evas_object_image_filled_set(). It has the same effect of applying those functions in sequence, which is a very common use case.
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasImage evas_object_image_filled_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:27'!
addLine

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasLine evas_object_line_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:20'!
addPolygon
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasPolygon evas_object_polygon_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/4/2012 23:44'!
addRectangle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasRectangle evas_object_rectangle_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/6/2012 01:46'!
addText
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasText evas_object_text_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:13'!
addTextblock
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasTextblock evas_object_textblock_add (#NBEvas self))! !

!NBEvas methodsFor: 'feeding' stamp: 'EgorScorik 6/18/2013 22:25'!
feedMouseDownButton: button
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_event_feed_mouse_down (NBEvas self, int button, 0, 0, nil))! !

!NBEvas methodsFor: 'feeding' stamp: 'EgorScorik 6/16/2013 03:33'!
feedMouseMoveX: x Y: y 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_event_feed_mouse_move (NBEvas self, int x, int y, 0, nil))! !

!NBEvas methodsFor: 'feeding' stamp: 'EgorScorik 6/18/2013 22:30'!
feedMouseUpButton: button
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_event_feed_mouse_up (NBEvas self, int button, 0, 0, nil))! !

!NBEvas methodsFor: 'initialize-release' stamp: 'EgorScorik 2/11/2012 21:02'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_free (#NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/11/2012 22:42'!
freeRenderMethodList: aList
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_render_method_list_free (#NBEinaList aList))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 4/28/2012 19:11'!
getEngineInfo
"Evas_Engine_Info* evas_engine_info_get	(const Evas *e)	
Retrieves the current render engine info struct from the given evas.

The returned structure is publicly modifiable. The contents are valid until either evas_engine_info_set or evas_render are called.

This structure does not need to be freed by the caller."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void* evas_engine_info_get (NBEvas self))! !

!NBEvas methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:41'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvas methodsFor: 'viewpoint' stamp: 'EgorScorik 2/12/2012 01:15'!
outputWidth: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_size_set (NBEvas self, int w, int h))! !

!NBEvas methodsFor: 'viewpoint' stamp: 'EgorScorik 10/20/2012 16:39'!
render
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_render (NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/11/2012 22:30'!
renderMethodList
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEinaList evas_render_method_list (#NBEvas self))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/12/2012 00:21'!
renderMethodLookup: aRenderName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int evas_render_method_lookup (String aRenderName))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 4/28/2012 19:09'!
setEngineInfo: info
"
Eina_Bool evas_engine_info_set (Evas * e, Evas_Engine_Info * info)
Applies the engine settings for the given evas from the given Evas_Engine_Info structure.

To get the Evas_Engine_Info structure to use, call evas_engine_info_get . Do not try to obtain a pointer to an Evas_Engine_Info structure in any other way.

You will need to call this function at least once before you can create objects on an evas or render that evas. Some engines allow their settings to be changed more than once.

Once called, the info pointer should be considered invalid."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_engine_info_set (NBEvas self, void* info))! !

!NBEvas methodsFor: 'engine' stamp: 'EgorScorik 2/12/2012 00:43'!
setOutputMethod: aMethodId
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_method_set (NBEvas self, int aMethodId))! !

!NBEvas methodsFor: 'finding' stamp: 'EgorScorik 4/29/2012 04:14'!
topAtX: x Y: y
"Evas_Object* evas_object_top_at_xy_get	(const Evas *e, Evas_Coord x, Evas_Coord y, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects )
Retrieve the Evas object stacked at the top of a given position in a canvas.

Parameters:
e	A handle to the canvas.
x	The horizontal coordinate of the position
y	The vertical coordinate of the position
include_pass_events_objects	Boolean flag to include or not objects which pass events in this calculation
include_hidden_objects	Boolean flag to include or not hidden objects in this calculation
Returns:
The Evas object that is over all other objects at the given position.
This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. The user can remove from from the query objects which are hidden and/or which are set to pass events."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEvasObject evas_object_top_at_xy_get (NBEvas self, int x, int y, 0, 0))! !

!NBEvas methodsFor: 'viewpoint' stamp: 'EgorScorik 2/12/2012 01:17'!
viewportX: x y: y width: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_output_viewport_set (NBEvas self, int x, int y, int w, int h))! !

NBExternalObject subclass: #NBEvasObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasObject commentStamp: '<historical>' prior: 0!
I am abstract evas object.

http://docs.enlightenment.org/auto/evas/group__Evas__Object__Group.html!

NBEvasObject subclass: #NBEvasImage
	instanceVariableNames: 'imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasImage commentStamp: '<historical>' prior: 0!
I am raster image.!

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:39'!
getImageInfo
	imageWidth := ByteArray new: 4.
	imageHeight := ByteArray new: 4.
	self getImageWidth: imageWidth height: imageHeight.
	imageWidth := imageWidth nbUlongAt: 1.
	imageHeight := imageHeight nbUlongAt: 1.! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 22:17'!
getImageWidth: width height: height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( void evas_object_image_size_get (#NBEvasImage self, int* width, int* height))! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight
	^ imageHeight! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight: anObject
	imageHeight := anObject! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth
	^ imageWidth! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth: anObject
	imageWidth := anObject! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:27'!
loadErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#int #evas_object_image_load_error_get #(#NBEvasImage #self))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:28'!
loadErrorFromCode: code
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#String #evas_load_error_str #(#int #code))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:46'!
setFile: aFilename key: key
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_image_file_set (#NBEvasImage self, String aFilename, nil))! !

NBEvasObject subclass: #NBEvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasLine commentStamp: '<historical>' prior: 0!
I am line.!

!NBEvasObject class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/16/2012 00:04'!
ffiCalloutOptions
	 ^ #( optMayGC )! !

!NBEvasObject class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libevas.so'! !

!NBEvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 00:52'!
addCallback: callback type: type data: data
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self nbCall: #(void evas_object_event_callback_add (NBEvasObject self, int type, NBEvasObjectCallback callback, void* data)) options: #(#optCoerceNilToNull)! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
colorR: r G: g B: b A: a
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_color_set (#NBEvasObject self, int r, int g, int b, int a))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:43'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_del (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'comparing' stamp: 'EgorScorik 5/7/2012 00:45'!
hash
	^self handle hash.! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
hide
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_hide (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
moveToX: x Y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_move (#NBEvasObject self, int x, int y))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:45'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
show
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_show (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
width: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_resize (#NBEvasObject self, int w, int h))! !

NBEvasObject subclass: #NBEvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasPolygon commentStamp: '<historical>' prior: 0!
I am polygon.!

NBEvasObject subclass: #NBEvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasRectangle commentStamp: '<historical>' prior: 0!
I am rectangle.!

NBEvasObject subclass: #NBEvasText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasText commentStamp: '<historical>' prior: 0!
I am single line simple text.!

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:59'!
setFont: aFontfamily size: size
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_set (NBEvasText self , String aFontfamily, int size))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 02:02'!
setFontSource: aFilename
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_source_set (NBEvasText self , String aFilename))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:58'!
setText: aString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#void #evas_object_text_text_set #(#NBEvasText self , String aString))! !

NBEvasObject subclass: #NBEvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasTextblock commentStamp: '<historical>' prior: 0!
I am styled multiline text block.!

NBFFICallback subclass: #NBEvasObjectCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasObjectCallback class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/16/2012 00:42'!
fnSpec

	^ #(void (void*, void*, void*, void*))! !

Announcement subclass: #SDLAnnouncement
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: 'SDLConstants'
	category: 'Egg-SDL'!

!SDLAnnouncement commentStamp: '<historical>' prior: 0!
I am announcment for SDLEvent!

SDLAnnouncement subclass: #Quit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!Quit commentStamp: '<historical>' prior: 0!
I am raised when user close a window
!

!SDLAnnouncement class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/2/2012 00:45'!
fromEvent: anEvent
	| inst |
	inst := self new.
	inst event: anEvent.
	^ inst! !

!SDLAnnouncement methodsFor: 'accessing' stamp: 'EgorScorik 6/14/2013 01:12'!
event
	^ event! !

!SDLAnnouncement methodsFor: 'accessing' stamp: 'EgorScorik 6/14/2013 01:12'!
event: anObject
	event := anObject! !

SDLAnnouncement subclass: #SDLWindowAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

SDLWindowAnnouncement subclass: #SDLKeyboardAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLKeyboardAnnouncement commentStamp: '<historical>' prior: 0!
One of my subclasess raised when user do something with a keyboard.!

SDLKeyboardAnnouncement subclass: #KeyDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!KeyDown commentStamp: '<historical>' prior: 0!
I am raised when user press a key!

!KeyDown methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 04:38'!
character
	"Unicode field filled only for key down event"
	^ Character value: self event unicode! !

SDLKeyboardAnnouncement subclass: #KeyUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!KeyUp commentStamp: '<historical>' prior: 0!
I am raised when user release a key!

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:01'!
ampersand

	^ self event sym = 38! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
asterisk

	^ self event sym = 42! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
at

	^ self event sym = 64! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
backSlash

	^ self event sym = 92! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
backquote

	^ self event sym = 96! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
backspace

	^ self event sym = 8! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
breakKey

	^ self event sym = 318! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:20'!
capsLock

	^(self event sym = 301) or: ((8192 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
caret

	^ self event sym = 94! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
clear

	^ self event sym = 12! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
colon

	^ self event sym = 58! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
comma

	^ self event sym = 44! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:24'!
compose

	^ self event sym = 314! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:10'!
delete

	^ self event sym = 127! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:58'!
dollar

	^ self event sym = 36! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:57'!
doubleQuote

	^ self event sym = 34! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
down

	^ self event sym = 274! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
end

	^ self event sym = 279! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
equals

	^ self event sym = 61! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
escape

	^ self event sym = 27! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
euro

	^ self event sym = 321! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:57'!
exclaim

	^ self event sym = 33! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f1

	^ self event sym = 282! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f10

	^ self event sym = 291! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f11

	^ self event sym = 292! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f12

	^ self event sym = 293! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f13

	^ self event sym = 294! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f14

	^ self event sym = 295! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:21'!
f15

	^ self event sym = 296! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f2

	^ self event sym = 283! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f3

	^ self event sym = 284! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f4

	^ self event sym = 285! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f5

	^ self event sym = 286! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f6

	^ self event sym = 287! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f7

	^ self event sym = 288! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f8

	^ self event sym = 289! !

!SDLKeyboardAnnouncement methodsFor: 'function' stamp: 'EgorScorik 3/20/2012 00:20'!
f9

	^ self event sym = 290! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
greater

	^ self event sym = 62! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
help

	^ self event sym = 315! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
home

	^ self event sym = 278! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
insert

	^ self event sym = 277! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key0

	^ self event sym = 48! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:52'!
key1

	^ self event sym = 49! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key2

	^ self event sym = 50! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key3

	^ self event sym = 51! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key4

	^ self event sym = 52! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key5

	^ self event sym = 53! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key6

	^ self event sym = 54! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:53'!
key7

	^ self event sym = 55! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key8

	^ self event sym = 56! !

!SDLKeyboardAnnouncement methodsFor: 'digits' stamp: 'EgorScorik 3/19/2012 23:54'!
key9

	^ self event sym = 57! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:44'!
keyA

	^ self event sym = 97! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:47'!
keyB

	^ self event sym = 98! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:47'!
keyD

	^ self event sym = 100! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyE

	^ self event sym = 101! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyF

	^ self event sym = 102! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyG

	^ self event sym = 103! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:48'!
keyH

	^ self event sym = 104! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyI

	^ self event sym = 105! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyJ

	^ self event sym = 106! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyK

	^ self event sym = 107! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyL

	^ self event sym = 108! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyM

	^ self event sym = 109! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyN

	^ self event sym = 110! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:49'!
keyO

	^ self event sym = 111! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyP

	^ self event sym = 112! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyQ

	^ self event sym = 113! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyR

	^ self event sym = 114! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyS

	^ self event sym = 115! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyT

	^ self event sym = 116! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:50'!
keyU

	^ self event sym = 117! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyV

	^ self event sym = 118! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyW

	^ self event sym = 119! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyX

	^ self event sym = 120! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyY

	^ self event sym = 121! !

!SDLKeyboardAnnouncement methodsFor: 'letters' stamp: 'EgorScorik 3/19/2012 23:51'!
keyZ

	^ self event sym = 122! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
left

	^ self event sym = 276! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:15'!
leftAlt

	^(self event sym = 308) or: ((256 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
leftBracket

	^ self event sym = 91! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:13'!
leftCtrl

	^ (self event sym = 306) or: ((64 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:16'!
leftMeta

	^(self event sym = 310) or: ((1024 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:03'!
leftParenthesis

	^ self event sym = 40! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:11'!
leftShift

	^ (self event sym = 304) or: ((1 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:23'!
leftSuper

	^ self event sym = 311! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
less

	^ self event sym = 60! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
menu

	^ self event sym = 319! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
minus

	^ self event sym = 45! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:20'!
mode
	^(self event sym = 313) or: ((16384 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:18'!
numLock

	^(self event sym = 300) or: ((4096 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/19/2012 23:59'!
numberSign

	^ self event sym = 35! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:12'!
numpad0

	^ self event sym = 256! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad1

	^ self event sym = 257! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad2

	^ self event sym = 258! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad3

	^ self event sym = 259! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad4

	^ self event sym = 260! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad5

	^ self event sym = 261! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad6

	^ self event sym = 262! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad7

	^ self event sym = 263! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad8

	^ self event sym = 264! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:13'!
numpad9

	^ self event sym = 265! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadDivide

	^ self event sym = 267! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadEnter

	^ self event sym = 271! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadEquals

	^ self event sym = 272! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadMinus

	^ self event sym = 269! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadMultiply

	^ self event sym = 268! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:14'!
numpadPeriod

	^ self event sym = 266! !

!SDLKeyboardAnnouncement methodsFor: 'numpad' stamp: 'EgorScorik 3/20/2012 00:15'!
numpadPlus

	^ self event sym = 270! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:12'!
pageDown

	^ self event sym = 281! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
pageUp

	^ self event sym = 280! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
pause

	^ self event sym = 19! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
period

	^ self event sym = 46! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:04'!
plus

	^ self event sym = 43! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
power

	^ self event sym = 320! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
print

	^ self event sym = 316! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:06'!
question

	^ self event sym = 63! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:01'!
quote

	^ self event sym = 39! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
return

	^ self event sym = 13! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:11'!
right

	^ self event sym = 275! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:16'!
rightAlt

	^(self event sym = 307) or: ((512 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
rightBracket

	^ self event sym = 93! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:14'!
rightCtrl

	^(self event sym = 305) or: ((128 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:18'!
rightMeta

	^(self event sym = 309) or: ((2048 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:03'!
rightParenthesis

	^ self event sym = 41! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/25/2012 02:12'!
rightShift

	^(self event sym = 303) or: ((2 bitAnd: self event mod) = 1)! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:24'!
rightSuper

	^ self event sym = 312! !

!SDLKeyboardAnnouncement methodsFor: 'as yet unclassified' stamp: 'EgorScorik 3/19/2012 04:27'!
scancode
	^ self event scancode! !

!SDLKeyboardAnnouncement methodsFor: 'modifiers' stamp: 'EgorScorik 3/20/2012 00:22'!
scrollLock

	^ self event sym = 302! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
semicolon

	^ self event sym = 59! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:05'!
slash

	^ self event sym = 47! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:09'!
space

	^ self event sym = 32! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:25'!
sysReq

	^ self event sym = 317! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:08'!
tab

	^ self event sym = 9! !

!SDLKeyboardAnnouncement methodsFor: 'signs' stamp: 'EgorScorik 3/20/2012 00:07'!
underscore

	^ self event sym = 95! !

!SDLKeyboardAnnouncement methodsFor: 'exsotic' stamp: 'EgorScorik 3/20/2012 00:26'!
undo

	^ self event sym = 322! !

!SDLKeyboardAnnouncement methodsFor: 'control' stamp: 'EgorScorik 3/20/2012 00:10'!
up

	^ self event sym = 273! !

SDLWindowAnnouncement subclass: #SDLMouseAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDLMouseAnnouncement commentStamp: '<historical>' prior: 0!
One of my subclasess raised when user do something with a mouse.
!

SDLMouseAnnouncement subclass: #MouseDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseDown commentStamp: '<historical>' prior: 0!
I am raised when user press mouse button!

!MouseDown methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/18/2013 22:29'!
feed: aNBEvas 

	aNBEvas feedMouseMoveX: event x Y: event y;
		        feedMouseDownButton: event button.
	! !

SDLMouseAnnouncement subclass: #MouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseMove commentStamp: '<historical>' prior: 0!
I am raised when user move mouse!

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:04'!
delta

	^ event xrel @ event yrel.! !

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:03'!
deltaX

	^ event xrel.! !

!MouseMove methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 03:03'!
deltaY

	^ event yrel.! !

!MouseMove methodsFor: 'feeding' stamp: 'EgorScorik 6/16/2013 03:50'!
feed: aNBEvas 

	aNBEvas feedMouseMoveX: event x Y: event y.! !

SDLMouseAnnouncement subclass: #MouseUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!MouseUp commentStamp: '<historical>' prior: 0!
I am raised when user release mouse button!

!MouseUp methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/18/2013 22:31'!
feed: aNBEvas 

	aNBEvas feedMouseMoveX: event x Y: event y;
		        feedMouseUpButton: event button.! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
leftButtonPressed
	^(1 bitAnd: event state) = 1
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
middleButtonPressed
	^(2 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
rightButtonPressed
	^(4 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
wheelDownButtonPressed
	^(16 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
wheelUpButtonPressed
	^(8 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 01:02'!
x
	^ event x.! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
x1ButtonPressed
	^(32 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'mouse-buttons' stamp: 'EgorScorik 3/19/2012 01:01'!
x2ButtonPressed
	^(64 bitAnd: event state) = 1.
	! !

!SDLMouseAnnouncement methodsFor: 'position' stamp: 'EgorScorik 3/19/2012 01:02'!
y
	^ event y.! !

!SDLWindowAnnouncement methodsFor: 'feeding' stamp: 'EgorScorik 6/16/2013 03:48'!
feed: aNBEvas

	! !

!SDLWindowAnnouncement methodsFor: 'windows' stamp: 'EgorScorik 6/13/2013 01:36'!
windowId

	^ event windowId.! !

TestCase subclass: #EvasTest
	instanceVariableNames: 'egg evas stage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

EvasTest subclass: #EvasImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

!EvasImageTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 19:36'!
testImage1
	| img top |
	img := self addTilesetImage.
	self assert: (img loadError = 'No error on load').
	top := evas topAt: 50 @ 50.
	self assert: top = img
! !

EvasTest subclass: #EvasRectangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:01'!
testRect1
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 50 @ 50.
	self assert: top = rect
! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:01'!
testRect2
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 500 @ 500.
	self assert: top = nil! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:04'!
testRect3
	| rect top |
	rect := self addRectangle: (Rectangle origin: 100 @ 100 extent: 100 @ 100 ).
	top := evas topAt: 100 @ 100.
	self assert: top = rect! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:05'!
testRect4
	| rect top |
	rect := self addRectangle: (Rectangle origin: -100 @ -100 extent: 100 @ 100 ).
	top := evas topAt: -50 @ -50.
	self assert: top = rect! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:07'!
testRect5
	| rect1 rect2 top |
	rect1 := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	rect2 := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 50 @ 50.
	self assert: top = rect2! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:18'!
testRect6
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	rect moveTo: 200 @ 200.
	top := evas topAt: 50 @ 50.
	self assert: top = nil.
	top := evas topAt: 250 @ 250.
	self assert: top = rect! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 00:37'!
addRectangle: aRectangle
	|rect|
	rect := EvasRectangle new.
	rect x: aRectangle origin x; y: aRectangle origin y; width: aRectangle width; height: aRectangle height; color: Color random.
	stage add: rect.
	^rect.
	
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 19:32'!
addTilesetImage
	|image|
	image := EvasImage new.
	image x:0; y:0.
	image sourceFile: '/home/egor/pharo/tiles/TileSetVX___Global_4.png'.
	stage add: image.
	^image.
	
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:00'!
setUp
	egg := Egg new.
	evas := egg evas.
	stage := egg stage.
	egg run.! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:00'!
tearDown
	egg finalize.! !

Object subclass: #Egg
	instanceVariableNames: 'session windows process announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

Egg class
	instanceVariableNames: 'instance'!

Egg class
	instanceVariableNames: 'instance'!

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/13/2013 00:59'!
instance

	instance ifNil: [ instance := Egg new ].
	^ instance.! !

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/13/2013 01:25'!
newInstance
	
	instance := Egg new.
	^ instance.! !

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/15/2013 00:33'!
shutDown

	self instance stop.
	NBEvas shutdown.! !

!Egg class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/15/2013 02:40'!
startUp

	NBEvas init.
	self instance start.! !

!Egg methodsFor: 'windows' stamp: 'EgorScorik 6/14/2013 01:40'!
addWindow: window 

	window regenerate.
	self windows at: window windowId put: window.
! !

!Egg methodsFor: 'events' stamp: 'EgorScorik 6/16/2013 03:44'!
announce: announce
	
	announce ifNil: [ ^nil ].
	(announce isKindOf: SDLWindowAnnouncement) ifTrue: [ 
		(self windows at: announce windowId) feed: announce.
	] ifFalse: [ self announcer announce: announce].
! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 01:38'!
announcer
	^ announcer! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 01:38'!
announcer: anObject
	announcer := anObject! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 6/13/2013 01:40'!
checkSession
	session = NativeBoost uniqueSessionObject
		ifFalse: [ 
			self regenerate.
			session := NativeBoost uniqueSessionObject ]! !

!Egg methodsFor: 'events' stamp: 'EgorScorik 6/14/2013 01:06'!
handleEvents
	| event  |
	event := SDLEvent new.
	[(SDL pollEvent: event) = 1] whileTrue: [
		self announce: (SDLEvent announcementFrom: event).
	].! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 6/14/2013 22:45'!
initialize
	super initialize.
	self session: NativeBoost uniqueSessionObject.
	self windows: Dictionary new.
	self announcer: Announcer new.
	self regenerate.
	self start.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 6/13/2013 01:53'!
mainLoop
	| ms msForDelay |
	ms := Time millisecondClockValue.
	self checkSession.
	self handleEvents.
	self windowsUpdate.
	ms := Time millisecondClockValue - ms.
	msForDelay := (1000.0 / 60) - ms.
	msForDelay > 0
		ifTrue: [ (Delay forMilliseconds: msForDelay) wait ]! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
process
	^ process! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
process: anObject
	process := anObject! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 6/14/2013 23:48'!
regenerate

	self windows do: [ :each | each regenerate ].! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:38'!
session
	^ session! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:38'!
session: anObject
	session := anObject! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 6/12/2013 23:51'!
start
	
	self stop.
	self process: [
		[ [ self mainLoop ] repeat ] ifError: [ self process debug ]
	] fork! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 6/12/2013 23:55'!
stop

	self process ifNotNil: [ self process terminate ].! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:38'!
windows
	^ windows! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:38'!
windows: anObject
	windows := anObject! !

!Egg methodsFor: 'windows' stamp: 'EgorScorik 6/15/2013 01:47'!
windowsUpdate
	self windows do: [ :each | each evas render ].! !

Object subclass: #EggWindow
	instanceVariableNames: 'evas windowId width height announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

!EggWindow class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/13/2013 00:43'!
width: width height: height

	^ self new
	width: width; height: height;
	yourself.
! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 01:50'!
announcer
	^ announcer! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 01:50'!
announcer: anObject
	announcer := anObject! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
evas
	^ evas! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
evas: anObject
	evas := anObject! !

!EggWindow methodsFor: 'events' stamp: 'EgorScorik 6/16/2013 03:47'!
feed: announce

	self announcer announce: announce.
	announce feed: self evas handler.! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:40'!
height
	^ height! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:40'!
height: anObject
	height := anObject! !

!EggWindow methodsFor: 'initialize-release' stamp: 'EgorScorik 6/13/2013 01:30'!
initialize

	super initialize.
	self announcer: Announcer new.! !

!EggWindow methodsFor: 'initialize-release' stamp: 'EgorScorik 6/13/2013 00:29'!
newEvas
	self evas: Evas new.
	self evas renderMethod: 'gl_sdl'.
	self evas
		width: self width;
		height: self height.
	self evas viewpoint: (Rectangle origin: 0 @ 0 extent: self width @ self height).
	self evas fullscreen: false.
	self evas update.
	self windowId: self evas windowId.
! !

!EggWindow methodsFor: 'initialize-release' stamp: 'EgorScorik 6/13/2013 00:45'!
open

	Egg instance addWindow: self.! !

!EggWindow methodsFor: 'initialize-release' stamp: 'EgorScorik 6/13/2013 00:47'!
regenerate

	self evas ifNil: [ self newEvas ] ifNotNil: [ self evas regenerate ].! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:40'!
width
	^ width! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:40'!
width: anObject
	width := anObject! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
windowId
	^ windowId! !

!EggWindow methodsFor: 'accessing' stamp: 'EgorScorik 6/12/2013 23:46'!
windowId: anObject
	windowId := anObject! !

Object subclass: #Evas
	instanceVariableNames: 'handler children renderMethod viewpoint width height fullscreen windowId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!Evas methodsFor: 'adding' stamp: 'EgorScorik 6/15/2013 00:55'!
add: anObject
	
	anObject bindOn: self handler.
	self children addIfNotPresent: anObject.
	anObject evas: self.
	anObject update.
	
	! !

!Evas methodsFor: 'adding' stamp: 'EgorScorik 11/15/2012 02:18'!
addRectangle: aRectangle
	|rect|
	rect := EvasRectangle new.
	rect
		x: aRectangle origin x;
		y: aRectangle origin y;
		width: aRectangle width;
		height: aRectangle height;
		color: Color random.
		
	self add: rect.
	^rect.
	! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
children
	^ children! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
children: anObject
	children := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
fullscreen
	^ fullscreen! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
fullscreen: anObject
	fullscreen := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
handler
	^ handler! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
handler: anObject
	handler := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
height
	^ height! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
height: anObject
	height := anObject! !

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 6/8/2013 02:56'!
initialize 

	self children: LinkedList new.
	self handler: NBEvas new.! !

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 6/15/2013 00:27'!
regenerate

	self handler: NBEvas new.
	self update.
	self children do: [ :each | each regenerate ].! !

!Evas methodsFor: 'rendering' stamp: 'EgorScorik 2/12/2012 14:45'!
render
	self handler render! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:04'!
renderMethod
	^ renderMethod! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 2/12/2012 01:32'!
renderMethod: aMethodName
	renderMethod := aMethodName.
	self updateRenderMethod.! !

!Evas methodsFor: 'rendering' stamp: 'EgorScorik 2/11/2012 22:47'!
renderMethods
	| list result |
	list := self handler renderMethodList.
	result := list asStringArray.
	self handler freeRenderMethodList: list.
	^result.! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 14:46'!
update
	self updateRenderMethod.
	self updateSize.
	self updateViewpoint.
	self updateEngineInfo.! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 6/13/2013 00:51'!
updateEngineInfo
	| pointer info |
	
	pointer := self handler getEngineInfo.
	pointer isNull
		ifTrue: [ ^ nil ].
	info := NBEvasEngineInfoSDL fromPointer: pointer.
	info fullscreen: (self fullscreen ifTrue: [ 1 ] ifFalse: [ 0 ]).
	self handler setEngineInfo: pointer.
	
	pointer := self handler getEngineInfo.
	info := NBEvasEngineInfoSDL fromPointer: pointer.
	self windowId: (SDL getWindowId: info window).
! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 01:33'!
updateRenderMethod
	| methodId |
	self renderMethod ifNil: [ self error: 'Wrong render method.' ].
	methodId := self handler renderMethodLookup: self renderMethod.
	methodId > 0
		ifTrue: [ self handler setOutputMethod: methodId ]! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 19:43'!
updateSize
	(self width isNil or: self height isNil)
		ifTrue: [ ^ nil ].
	self handler ifNotNil: [ self handler outputWidth: self width height: self height ]! !

!Evas methodsFor: 'updating' stamp: 'EgorScorik 2/12/2012 01:45'!
updateViewpoint
	self handler
		ifNotNil: [ 
			self viewpoint
				ifNotNil: [ 
					self handler
						viewportX: self viewpoint origin x
						y: self viewpoint origin y
						width: self viewpoint width
						height: self viewpoint height ] ]! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
viewpoint
	^ viewpoint! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
viewpoint: anObject
	viewpoint := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
width
	^ width! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/8/2013 02:49'!
width: anObject
	width := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:54'!
windowId
	^ windowId! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 6/13/2013 00:54'!
windowId: anObject
	windowId := anObject! !

Object subclass: #SDL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-SDL'!

!SDL commentStamp: '<historical>' prior: 0!
I am wrapper for libsdl (http://www.libsdl.org/)!

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/14/2013 02:20'!
getWindowId: window
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(uint SDL_GetWindowID (void* window))! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/13/2013 00:20'!
nbLibraryNameOrHandle

	NativeBoost platformId = NativeBoostConstants win32PlatformId ifTrue: [^ './SDL2.dll' ].
	NativeBoost platformId = NativeBoostConstants linux32PlatformId ifTrue: [^ '/usr/local/lib/libSDL2.so' ].! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 6/14/2013 02:19'!
pollEvent: aEvent
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int SDL_PollEvent (void* aEvent))! !

!SDL class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 2/26/2012 20:09'!
pumpEvents
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void SDL_PumpEvents ())! !
SDLConstants initialize!
